/** @file
 * VirtualBox API class wrapper code for ISystemProperties.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/**
 * Copyright (C) 2010-2015 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#define LOG_GROUP_MAIN_OVERRIDE LOG_GROUP_MAIN_SYSTEMPROPERTIES

#include "SystemPropertiesWrap.h"
#include "Logging.h"
#ifdef VBOX_WITH_DTRACE_R3_MAIN
# include "dtrace/VBoxAPI.h"
#endif

DEFINE_EMPTY_CTOR_DTOR(SystemPropertiesWrap)

//
// ISystemProperties properties
//

STDMETHODIMP SystemPropertiesWrap::COMGETTER(MinGuestRAM)(ULONG *aMinGuestRAM)
{
    LogRelFlow(("{%p} %s: enter aMinGuestRAM=%p\n", this, "SystemProperties::getMinGuestRAM", aMinGuestRAM));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMinGuestRAM);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MINGUESTRAM_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMinGuestRAM(aMinGuestRAM);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MINGUESTRAM_RETURN(this, hrc, 0 /*normal*/,*aMinGuestRAM);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MINGUESTRAM_RETURN(this, hrc, 1 /*hrc exception*/,*aMinGuestRAM);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MINGUESTRAM_RETURN(this, hrc, 9 /*unhandled exception*/,*aMinGuestRAM);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aMinGuestRAM=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMinGuestRAM", *aMinGuestRAM, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(MaxGuestRAM)(ULONG *aMaxGuestRAM)
{
    LogRelFlow(("{%p} %s: enter aMaxGuestRAM=%p\n", this, "SystemProperties::getMaxGuestRAM", aMaxGuestRAM));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMaxGuestRAM);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTRAM_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMaxGuestRAM(aMaxGuestRAM);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTRAM_RETURN(this, hrc, 0 /*normal*/,*aMaxGuestRAM);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTRAM_RETURN(this, hrc, 1 /*hrc exception*/,*aMaxGuestRAM);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTRAM_RETURN(this, hrc, 9 /*unhandled exception*/,*aMaxGuestRAM);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aMaxGuestRAM=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMaxGuestRAM", *aMaxGuestRAM, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(MinGuestVRAM)(ULONG *aMinGuestVRAM)
{
    LogRelFlow(("{%p} %s: enter aMinGuestVRAM=%p\n", this, "SystemProperties::getMinGuestVRAM", aMinGuestVRAM));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMinGuestVRAM);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MINGUESTVRAM_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMinGuestVRAM(aMinGuestVRAM);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MINGUESTVRAM_RETURN(this, hrc, 0 /*normal*/,*aMinGuestVRAM);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MINGUESTVRAM_RETURN(this, hrc, 1 /*hrc exception*/,*aMinGuestVRAM);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MINGUESTVRAM_RETURN(this, hrc, 9 /*unhandled exception*/,*aMinGuestVRAM);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aMinGuestVRAM=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMinGuestVRAM", *aMinGuestVRAM, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(MaxGuestVRAM)(ULONG *aMaxGuestVRAM)
{
    LogRelFlow(("{%p} %s: enter aMaxGuestVRAM=%p\n", this, "SystemProperties::getMaxGuestVRAM", aMaxGuestVRAM));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMaxGuestVRAM);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTVRAM_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMaxGuestVRAM(aMaxGuestVRAM);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTVRAM_RETURN(this, hrc, 0 /*normal*/,*aMaxGuestVRAM);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTVRAM_RETURN(this, hrc, 1 /*hrc exception*/,*aMaxGuestVRAM);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTVRAM_RETURN(this, hrc, 9 /*unhandled exception*/,*aMaxGuestVRAM);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aMaxGuestVRAM=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMaxGuestVRAM", *aMaxGuestVRAM, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(MinGuestCPUCount)(ULONG *aMinGuestCPUCount)
{
    LogRelFlow(("{%p} %s: enter aMinGuestCPUCount=%p\n", this, "SystemProperties::getMinGuestCPUCount", aMinGuestCPUCount));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMinGuestCPUCount);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MINGUESTCPUCOUNT_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMinGuestCPUCount(aMinGuestCPUCount);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MINGUESTCPUCOUNT_RETURN(this, hrc, 0 /*normal*/,*aMinGuestCPUCount);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MINGUESTCPUCOUNT_RETURN(this, hrc, 1 /*hrc exception*/,*aMinGuestCPUCount);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MINGUESTCPUCOUNT_RETURN(this, hrc, 9 /*unhandled exception*/,*aMinGuestCPUCount);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aMinGuestCPUCount=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMinGuestCPUCount", *aMinGuestCPUCount, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(MaxGuestCPUCount)(ULONG *aMaxGuestCPUCount)
{
    LogRelFlow(("{%p} %s: enter aMaxGuestCPUCount=%p\n", this, "SystemProperties::getMaxGuestCPUCount", aMaxGuestCPUCount));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMaxGuestCPUCount);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTCPUCOUNT_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMaxGuestCPUCount(aMaxGuestCPUCount);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTCPUCOUNT_RETURN(this, hrc, 0 /*normal*/,*aMaxGuestCPUCount);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTCPUCOUNT_RETURN(this, hrc, 1 /*hrc exception*/,*aMaxGuestCPUCount);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTCPUCOUNT_RETURN(this, hrc, 9 /*unhandled exception*/,*aMaxGuestCPUCount);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aMaxGuestCPUCount=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMaxGuestCPUCount", *aMaxGuestCPUCount, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(MaxGuestMonitors)(ULONG *aMaxGuestMonitors)
{
    LogRelFlow(("{%p} %s: enter aMaxGuestMonitors=%p\n", this, "SystemProperties::getMaxGuestMonitors", aMaxGuestMonitors));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMaxGuestMonitors);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTMONITORS_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMaxGuestMonitors(aMaxGuestMonitors);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTMONITORS_RETURN(this, hrc, 0 /*normal*/,*aMaxGuestMonitors);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTMONITORS_RETURN(this, hrc, 1 /*hrc exception*/,*aMaxGuestMonitors);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXGUESTMONITORS_RETURN(this, hrc, 9 /*unhandled exception*/,*aMaxGuestMonitors);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aMaxGuestMonitors=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMaxGuestMonitors", *aMaxGuestMonitors, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InfoVDSize)(LONG64 *aInfoVDSize)
{
    LogRelFlow(("{%p} %s: enter aInfoVDSize=%p\n", this, "SystemProperties::getInfoVDSize", aInfoVDSize));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aInfoVDSize);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_INFOVDSIZE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getInfoVDSize(aInfoVDSize);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_INFOVDSIZE_RETURN(this, hrc, 0 /*normal*/,*aInfoVDSize);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_INFOVDSIZE_RETURN(this, hrc, 1 /*hrc exception*/,*aInfoVDSize);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_INFOVDSIZE_RETURN(this, hrc, 9 /*unhandled exception*/,*aInfoVDSize);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aInfoVDSize=%RI64 hrc=%Rhrc\n", this, "SystemProperties::getInfoVDSize", *aInfoVDSize, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(SerialPortCount)(ULONG *aSerialPortCount)
{
    LogRelFlow(("{%p} %s: enter aSerialPortCount=%p\n", this, "SystemProperties::getSerialPortCount", aSerialPortCount));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aSerialPortCount);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_SERIALPORTCOUNT_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getSerialPortCount(aSerialPortCount);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_SERIALPORTCOUNT_RETURN(this, hrc, 0 /*normal*/,*aSerialPortCount);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_SERIALPORTCOUNT_RETURN(this, hrc, 1 /*hrc exception*/,*aSerialPortCount);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_SERIALPORTCOUNT_RETURN(this, hrc, 9 /*unhandled exception*/,*aSerialPortCount);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aSerialPortCount=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getSerialPortCount", *aSerialPortCount, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(ParallelPortCount)(ULONG *aParallelPortCount)
{
    LogRelFlow(("{%p} %s: enter aParallelPortCount=%p\n", this, "SystemProperties::getParallelPortCount", aParallelPortCount));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aParallelPortCount);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_PARALLELPORTCOUNT_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getParallelPortCount(aParallelPortCount);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_PARALLELPORTCOUNT_RETURN(this, hrc, 0 /*normal*/,*aParallelPortCount);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_PARALLELPORTCOUNT_RETURN(this, hrc, 1 /*hrc exception*/,*aParallelPortCount);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_PARALLELPORTCOUNT_RETURN(this, hrc, 9 /*unhandled exception*/,*aParallelPortCount);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aParallelPortCount=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getParallelPortCount", *aParallelPortCount, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(MaxBootPosition)(ULONG *aMaxBootPosition)
{
    LogRelFlow(("{%p} %s: enter aMaxBootPosition=%p\n", this, "SystemProperties::getMaxBootPosition", aMaxBootPosition));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMaxBootPosition);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXBOOTPOSITION_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMaxBootPosition(aMaxBootPosition);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXBOOTPOSITION_RETURN(this, hrc, 0 /*normal*/,*aMaxBootPosition);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXBOOTPOSITION_RETURN(this, hrc, 1 /*hrc exception*/,*aMaxBootPosition);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MAXBOOTPOSITION_RETURN(this, hrc, 9 /*unhandled exception*/,*aMaxBootPosition);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aMaxBootPosition=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMaxBootPosition", *aMaxBootPosition, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(RawModeSupported)(BOOL *aRawModeSupported)
{
    LogRelFlow(("{%p} %s: enter aRawModeSupported=%p\n", this, "SystemProperties::getRawModeSupported", aRawModeSupported));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aRawModeSupported);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_RAWMODESUPPORTED_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getRawModeSupported(aRawModeSupported);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_RAWMODESUPPORTED_RETURN(this, hrc, 0 /*normal*/,*aRawModeSupported != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_RAWMODESUPPORTED_RETURN(this, hrc, 1 /*hrc exception*/,*aRawModeSupported != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_RAWMODESUPPORTED_RETURN(this, hrc, 9 /*unhandled exception*/,*aRawModeSupported != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aRawModeSupported=%RTbool hrc=%Rhrc\n", this, "SystemProperties::getRawModeSupported", *aRawModeSupported, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(ExclusiveHwVirt)(BOOL *aExclusiveHwVirt)
{
    LogRelFlow(("{%p} %s: enter aExclusiveHwVirt=%p\n", this, "SystemProperties::getExclusiveHwVirt", aExclusiveHwVirt));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aExclusiveHwVirt);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_EXCLUSIVEHWVIRT_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getExclusiveHwVirt(aExclusiveHwVirt);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_EXCLUSIVEHWVIRT_RETURN(this, hrc, 0 /*normal*/,*aExclusiveHwVirt != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_EXCLUSIVEHWVIRT_RETURN(this, hrc, 1 /*hrc exception*/,*aExclusiveHwVirt != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_EXCLUSIVEHWVIRT_RETURN(this, hrc, 9 /*unhandled exception*/,*aExclusiveHwVirt != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aExclusiveHwVirt=%RTbool hrc=%Rhrc\n", this, "SystemProperties::getExclusiveHwVirt", *aExclusiveHwVirt, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(ExclusiveHwVirt)(BOOL aExclusiveHwVirt)
{
    LogRelFlow(("{%p} %s: enter aExclusiveHwVirt=%RTbool\n", this, "SystemProperties::setExclusiveHwVirt", aExclusiveHwVirt));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_EXCLUSIVEHWVIRT_ENTER(this, aExclusiveHwVirt != FALSE);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setExclusiveHwVirt(aExclusiveHwVirt != FALSE);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_EXCLUSIVEHWVIRT_RETURN(this, hrc, 0 /*normal*/,aExclusiveHwVirt != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_EXCLUSIVEHWVIRT_RETURN(this, hrc, 1 /*hrc exception*/,aExclusiveHwVirt != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_EXCLUSIVEHWVIRT_RETURN(this, hrc, 9 /*unhandled exception*/,aExclusiveHwVirt != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setExclusiveHwVirt", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(DefaultMachineFolder)(BSTR *aDefaultMachineFolder)
{
    LogRelFlow(("{%p} %s: enter aDefaultMachineFolder=%p\n", this, "SystemProperties::getDefaultMachineFolder", aDefaultMachineFolder));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aDefaultMachineFolder);
        BSTROutConverter TmpDefaultMachineFolder(aDefaultMachineFolder);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTMACHINEFOLDER_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getDefaultMachineFolder(TmpDefaultMachineFolder.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTMACHINEFOLDER_RETURN(this, hrc, 0 /*normal*/,TmpDefaultMachineFolder.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTMACHINEFOLDER_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTMACHINEFOLDER_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aDefaultMachineFolder=%ls hrc=%Rhrc\n", this, "SystemProperties::getDefaultMachineFolder", *aDefaultMachineFolder, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(DefaultMachineFolder)(IN_BSTR aDefaultMachineFolder)
{
    LogRelFlow(("{%p} %s: enter aDefaultMachineFolder=%ls\n", this, "SystemProperties::setDefaultMachineFolder", aDefaultMachineFolder));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        BSTRInConverter TmpDefaultMachineFolder(aDefaultMachineFolder);

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTMACHINEFOLDER_ENTER(this, TmpDefaultMachineFolder.str().c_str());
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setDefaultMachineFolder(TmpDefaultMachineFolder.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTMACHINEFOLDER_RETURN(this, hrc, 0 /*normal*/,TmpDefaultMachineFolder.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTMACHINEFOLDER_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTMACHINEFOLDER_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setDefaultMachineFolder", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(LoggingLevel)(BSTR *aLoggingLevel)
{
    LogRelFlow(("{%p} %s: enter aLoggingLevel=%p\n", this, "SystemProperties::getLoggingLevel", aLoggingLevel));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aLoggingLevel);
        BSTROutConverter TmpLoggingLevel(aLoggingLevel);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_LOGGINGLEVEL_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getLoggingLevel(TmpLoggingLevel.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_LOGGINGLEVEL_RETURN(this, hrc, 0 /*normal*/,TmpLoggingLevel.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_LOGGINGLEVEL_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_LOGGINGLEVEL_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aLoggingLevel=%ls hrc=%Rhrc\n", this, "SystemProperties::getLoggingLevel", *aLoggingLevel, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(LoggingLevel)(IN_BSTR aLoggingLevel)
{
    LogRelFlow(("{%p} %s: enter aLoggingLevel=%ls\n", this, "SystemProperties::setLoggingLevel", aLoggingLevel));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        BSTRInConverter TmpLoggingLevel(aLoggingLevel);

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_LOGGINGLEVEL_ENTER(this, TmpLoggingLevel.str().c_str());
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setLoggingLevel(TmpLoggingLevel.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_LOGGINGLEVEL_RETURN(this, hrc, 0 /*normal*/,TmpLoggingLevel.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_LOGGINGLEVEL_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_LOGGINGLEVEL_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setLoggingLevel", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(MediumFormats)(ComSafeArrayOut(IMediumFormat *, aMediumFormats))
{
    LogRelFlow(("{%p} %s: enter aMediumFormats=%p\n", this, "SystemProperties::getMediumFormats", aMediumFormats));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMediumFormats);
        ArrayComTypeOutConverter<IMediumFormat> TmpMediumFormats(ComSafeArrayOutArg(aMediumFormats));
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MEDIUMFORMATS_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMediumFormats(TmpMediumFormats.array());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MEDIUMFORMATS_RETURN(this, hrc, 0 /*normal*/,(uint32_t)TmpMediumFormats.array().size(), NULL /*for now*/);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MEDIUMFORMATS_RETURN(this, hrc, 1 /*hrc exception*/,0, 0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_MEDIUMFORMATS_RETURN(this, hrc, 9 /*unhandled exception*/,0, 0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aMediumFormats=%zu hrc=%Rhrc\n", this, "SystemProperties::getMediumFormats", ComSafeArraySize(*aMediumFormats), hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(DefaultHardDiskFormat)(BSTR *aDefaultHardDiskFormat)
{
    LogRelFlow(("{%p} %s: enter aDefaultHardDiskFormat=%p\n", this, "SystemProperties::getDefaultHardDiskFormat", aDefaultHardDiskFormat));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aDefaultHardDiskFormat);
        BSTROutConverter TmpDefaultHardDiskFormat(aDefaultHardDiskFormat);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTHARDDISKFORMAT_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getDefaultHardDiskFormat(TmpDefaultHardDiskFormat.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTHARDDISKFORMAT_RETURN(this, hrc, 0 /*normal*/,TmpDefaultHardDiskFormat.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTHARDDISKFORMAT_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTHARDDISKFORMAT_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aDefaultHardDiskFormat=%ls hrc=%Rhrc\n", this, "SystemProperties::getDefaultHardDiskFormat", *aDefaultHardDiskFormat, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(DefaultHardDiskFormat)(IN_BSTR aDefaultHardDiskFormat)
{
    LogRelFlow(("{%p} %s: enter aDefaultHardDiskFormat=%ls\n", this, "SystemProperties::setDefaultHardDiskFormat", aDefaultHardDiskFormat));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        BSTRInConverter TmpDefaultHardDiskFormat(aDefaultHardDiskFormat);

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTHARDDISKFORMAT_ENTER(this, TmpDefaultHardDiskFormat.str().c_str());
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setDefaultHardDiskFormat(TmpDefaultHardDiskFormat.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTHARDDISKFORMAT_RETURN(this, hrc, 0 /*normal*/,TmpDefaultHardDiskFormat.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTHARDDISKFORMAT_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTHARDDISKFORMAT_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setDefaultHardDiskFormat", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(FreeDiskSpaceWarning)(LONG64 *aFreeDiskSpaceWarning)
{
    LogRelFlow(("{%p} %s: enter aFreeDiskSpaceWarning=%p\n", this, "SystemProperties::getFreeDiskSpaceWarning", aFreeDiskSpaceWarning));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aFreeDiskSpaceWarning);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEWARNING_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getFreeDiskSpaceWarning(aFreeDiskSpaceWarning);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEWARNING_RETURN(this, hrc, 0 /*normal*/,*aFreeDiskSpaceWarning);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEWARNING_RETURN(this, hrc, 1 /*hrc exception*/,*aFreeDiskSpaceWarning);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEWARNING_RETURN(this, hrc, 9 /*unhandled exception*/,*aFreeDiskSpaceWarning);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aFreeDiskSpaceWarning=%RI64 hrc=%Rhrc\n", this, "SystemProperties::getFreeDiskSpaceWarning", *aFreeDiskSpaceWarning, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(FreeDiskSpaceWarning)(LONG64 aFreeDiskSpaceWarning)
{
    LogRelFlow(("{%p} %s: enter aFreeDiskSpaceWarning=%RI64\n", this, "SystemProperties::setFreeDiskSpaceWarning", aFreeDiskSpaceWarning));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEWARNING_ENTER(this, aFreeDiskSpaceWarning);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setFreeDiskSpaceWarning(aFreeDiskSpaceWarning);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEWARNING_RETURN(this, hrc, 0 /*normal*/,aFreeDiskSpaceWarning);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEWARNING_RETURN(this, hrc, 1 /*hrc exception*/,aFreeDiskSpaceWarning);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEWARNING_RETURN(this, hrc, 9 /*unhandled exception*/,aFreeDiskSpaceWarning);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setFreeDiskSpaceWarning", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(FreeDiskSpacePercentWarning)(ULONG *aFreeDiskSpacePercentWarning)
{
    LogRelFlow(("{%p} %s: enter aFreeDiskSpacePercentWarning=%p\n", this, "SystemProperties::getFreeDiskSpacePercentWarning", aFreeDiskSpacePercentWarning));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aFreeDiskSpacePercentWarning);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEPERCENTWARNING_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getFreeDiskSpacePercentWarning(aFreeDiskSpacePercentWarning);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEPERCENTWARNING_RETURN(this, hrc, 0 /*normal*/,*aFreeDiskSpacePercentWarning);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEPERCENTWARNING_RETURN(this, hrc, 1 /*hrc exception*/,*aFreeDiskSpacePercentWarning);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEPERCENTWARNING_RETURN(this, hrc, 9 /*unhandled exception*/,*aFreeDiskSpacePercentWarning);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aFreeDiskSpacePercentWarning=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getFreeDiskSpacePercentWarning", *aFreeDiskSpacePercentWarning, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(FreeDiskSpacePercentWarning)(ULONG aFreeDiskSpacePercentWarning)
{
    LogRelFlow(("{%p} %s: enter aFreeDiskSpacePercentWarning=%RU32\n", this, "SystemProperties::setFreeDiskSpacePercentWarning", aFreeDiskSpacePercentWarning));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEPERCENTWARNING_ENTER(this, aFreeDiskSpacePercentWarning);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setFreeDiskSpacePercentWarning(aFreeDiskSpacePercentWarning);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEPERCENTWARNING_RETURN(this, hrc, 0 /*normal*/,aFreeDiskSpacePercentWarning);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEPERCENTWARNING_RETURN(this, hrc, 1 /*hrc exception*/,aFreeDiskSpacePercentWarning);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEPERCENTWARNING_RETURN(this, hrc, 9 /*unhandled exception*/,aFreeDiskSpacePercentWarning);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setFreeDiskSpacePercentWarning", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(FreeDiskSpaceError)(LONG64 *aFreeDiskSpaceError)
{
    LogRelFlow(("{%p} %s: enter aFreeDiskSpaceError=%p\n", this, "SystemProperties::getFreeDiskSpaceError", aFreeDiskSpaceError));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aFreeDiskSpaceError);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEERROR_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getFreeDiskSpaceError(aFreeDiskSpaceError);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEERROR_RETURN(this, hrc, 0 /*normal*/,*aFreeDiskSpaceError);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEERROR_RETURN(this, hrc, 1 /*hrc exception*/,*aFreeDiskSpaceError);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEERROR_RETURN(this, hrc, 9 /*unhandled exception*/,*aFreeDiskSpaceError);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aFreeDiskSpaceError=%RI64 hrc=%Rhrc\n", this, "SystemProperties::getFreeDiskSpaceError", *aFreeDiskSpaceError, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(FreeDiskSpaceError)(LONG64 aFreeDiskSpaceError)
{
    LogRelFlow(("{%p} %s: enter aFreeDiskSpaceError=%RI64\n", this, "SystemProperties::setFreeDiskSpaceError", aFreeDiskSpaceError));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEERROR_ENTER(this, aFreeDiskSpaceError);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setFreeDiskSpaceError(aFreeDiskSpaceError);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEERROR_RETURN(this, hrc, 0 /*normal*/,aFreeDiskSpaceError);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEERROR_RETURN(this, hrc, 1 /*hrc exception*/,aFreeDiskSpaceError);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEERROR_RETURN(this, hrc, 9 /*unhandled exception*/,aFreeDiskSpaceError);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setFreeDiskSpaceError", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(FreeDiskSpacePercentError)(ULONG *aFreeDiskSpacePercentError)
{
    LogRelFlow(("{%p} %s: enter aFreeDiskSpacePercentError=%p\n", this, "SystemProperties::getFreeDiskSpacePercentError", aFreeDiskSpacePercentError));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aFreeDiskSpacePercentError);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEPERCENTERROR_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getFreeDiskSpacePercentError(aFreeDiskSpacePercentError);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEPERCENTERROR_RETURN(this, hrc, 0 /*normal*/,*aFreeDiskSpacePercentError);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEPERCENTERROR_RETURN(this, hrc, 1 /*hrc exception*/,*aFreeDiskSpacePercentError);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_FREEDISKSPACEPERCENTERROR_RETURN(this, hrc, 9 /*unhandled exception*/,*aFreeDiskSpacePercentError);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aFreeDiskSpacePercentError=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getFreeDiskSpacePercentError", *aFreeDiskSpacePercentError, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(FreeDiskSpacePercentError)(ULONG aFreeDiskSpacePercentError)
{
    LogRelFlow(("{%p} %s: enter aFreeDiskSpacePercentError=%RU32\n", this, "SystemProperties::setFreeDiskSpacePercentError", aFreeDiskSpacePercentError));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEPERCENTERROR_ENTER(this, aFreeDiskSpacePercentError);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setFreeDiskSpacePercentError(aFreeDiskSpacePercentError);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEPERCENTERROR_RETURN(this, hrc, 0 /*normal*/,aFreeDiskSpacePercentError);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEPERCENTERROR_RETURN(this, hrc, 1 /*hrc exception*/,aFreeDiskSpacePercentError);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_FREEDISKSPACEPERCENTERROR_RETURN(this, hrc, 9 /*unhandled exception*/,aFreeDiskSpacePercentError);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setFreeDiskSpacePercentError", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(VRDEAuthLibrary)(BSTR *aVRDEAuthLibrary)
{
    LogRelFlow(("{%p} %s: enter aVRDEAuthLibrary=%p\n", this, "SystemProperties::getVRDEAuthLibrary", aVRDEAuthLibrary));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aVRDEAuthLibrary);
        BSTROutConverter TmpVRDEAuthLibrary(aVRDEAuthLibrary);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_VRDEAUTHLIBRARY_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getVRDEAuthLibrary(TmpVRDEAuthLibrary.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_VRDEAUTHLIBRARY_RETURN(this, hrc, 0 /*normal*/,TmpVRDEAuthLibrary.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_VRDEAUTHLIBRARY_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_VRDEAUTHLIBRARY_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aVRDEAuthLibrary=%ls hrc=%Rhrc\n", this, "SystemProperties::getVRDEAuthLibrary", *aVRDEAuthLibrary, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(VRDEAuthLibrary)(IN_BSTR aVRDEAuthLibrary)
{
    LogRelFlow(("{%p} %s: enter aVRDEAuthLibrary=%ls\n", this, "SystemProperties::setVRDEAuthLibrary", aVRDEAuthLibrary));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        BSTRInConverter TmpVRDEAuthLibrary(aVRDEAuthLibrary);

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_VRDEAUTHLIBRARY_ENTER(this, TmpVRDEAuthLibrary.str().c_str());
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setVRDEAuthLibrary(TmpVRDEAuthLibrary.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_VRDEAUTHLIBRARY_RETURN(this, hrc, 0 /*normal*/,TmpVRDEAuthLibrary.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_VRDEAUTHLIBRARY_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_VRDEAUTHLIBRARY_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setVRDEAuthLibrary", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(WebServiceAuthLibrary)(BSTR *aWebServiceAuthLibrary)
{
    LogRelFlow(("{%p} %s: enter aWebServiceAuthLibrary=%p\n", this, "SystemProperties::getWebServiceAuthLibrary", aWebServiceAuthLibrary));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aWebServiceAuthLibrary);
        BSTROutConverter TmpWebServiceAuthLibrary(aWebServiceAuthLibrary);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_WEBSERVICEAUTHLIBRARY_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getWebServiceAuthLibrary(TmpWebServiceAuthLibrary.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_WEBSERVICEAUTHLIBRARY_RETURN(this, hrc, 0 /*normal*/,TmpWebServiceAuthLibrary.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_WEBSERVICEAUTHLIBRARY_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_WEBSERVICEAUTHLIBRARY_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aWebServiceAuthLibrary=%ls hrc=%Rhrc\n", this, "SystemProperties::getWebServiceAuthLibrary", *aWebServiceAuthLibrary, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(WebServiceAuthLibrary)(IN_BSTR aWebServiceAuthLibrary)
{
    LogRelFlow(("{%p} %s: enter aWebServiceAuthLibrary=%ls\n", this, "SystemProperties::setWebServiceAuthLibrary", aWebServiceAuthLibrary));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        BSTRInConverter TmpWebServiceAuthLibrary(aWebServiceAuthLibrary);

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_WEBSERVICEAUTHLIBRARY_ENTER(this, TmpWebServiceAuthLibrary.str().c_str());
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setWebServiceAuthLibrary(TmpWebServiceAuthLibrary.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_WEBSERVICEAUTHLIBRARY_RETURN(this, hrc, 0 /*normal*/,TmpWebServiceAuthLibrary.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_WEBSERVICEAUTHLIBRARY_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_WEBSERVICEAUTHLIBRARY_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setWebServiceAuthLibrary", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(DefaultVRDEExtPack)(BSTR *aDefaultVRDEExtPack)
{
    LogRelFlow(("{%p} %s: enter aDefaultVRDEExtPack=%p\n", this, "SystemProperties::getDefaultVRDEExtPack", aDefaultVRDEExtPack));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aDefaultVRDEExtPack);
        BSTROutConverter TmpDefaultVRDEExtPack(aDefaultVRDEExtPack);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTVRDEEXTPACK_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getDefaultVRDEExtPack(TmpDefaultVRDEExtPack.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTVRDEEXTPACK_RETURN(this, hrc, 0 /*normal*/,TmpDefaultVRDEExtPack.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTVRDEEXTPACK_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTVRDEEXTPACK_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aDefaultVRDEExtPack=%ls hrc=%Rhrc\n", this, "SystemProperties::getDefaultVRDEExtPack", *aDefaultVRDEExtPack, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(DefaultVRDEExtPack)(IN_BSTR aDefaultVRDEExtPack)
{
    LogRelFlow(("{%p} %s: enter aDefaultVRDEExtPack=%ls\n", this, "SystemProperties::setDefaultVRDEExtPack", aDefaultVRDEExtPack));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        BSTRInConverter TmpDefaultVRDEExtPack(aDefaultVRDEExtPack);

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTVRDEEXTPACK_ENTER(this, TmpDefaultVRDEExtPack.str().c_str());
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setDefaultVRDEExtPack(TmpDefaultVRDEExtPack.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTVRDEEXTPACK_RETURN(this, hrc, 0 /*normal*/,TmpDefaultVRDEExtPack.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTVRDEEXTPACK_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTVRDEEXTPACK_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setDefaultVRDEExtPack", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(LogHistoryCount)(ULONG *aLogHistoryCount)
{
    LogRelFlow(("{%p} %s: enter aLogHistoryCount=%p\n", this, "SystemProperties::getLogHistoryCount", aLogHistoryCount));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aLogHistoryCount);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_LOGHISTORYCOUNT_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getLogHistoryCount(aLogHistoryCount);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_LOGHISTORYCOUNT_RETURN(this, hrc, 0 /*normal*/,*aLogHistoryCount);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_LOGHISTORYCOUNT_RETURN(this, hrc, 1 /*hrc exception*/,*aLogHistoryCount);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_LOGHISTORYCOUNT_RETURN(this, hrc, 9 /*unhandled exception*/,*aLogHistoryCount);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aLogHistoryCount=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getLogHistoryCount", *aLogHistoryCount, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(LogHistoryCount)(ULONG aLogHistoryCount)
{
    LogRelFlow(("{%p} %s: enter aLogHistoryCount=%RU32\n", this, "SystemProperties::setLogHistoryCount", aLogHistoryCount));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_LOGHISTORYCOUNT_ENTER(this, aLogHistoryCount);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setLogHistoryCount(aLogHistoryCount);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_LOGHISTORYCOUNT_RETURN(this, hrc, 0 /*normal*/,aLogHistoryCount);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_LOGHISTORYCOUNT_RETURN(this, hrc, 1 /*hrc exception*/,aLogHistoryCount);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_LOGHISTORYCOUNT_RETURN(this, hrc, 9 /*unhandled exception*/,aLogHistoryCount);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setLogHistoryCount", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(DefaultAudioDriver)(AudioDriverType_T *aDefaultAudioDriver)
{
    LogRelFlow(("{%p} %s: enter aDefaultAudioDriver=%p\n", this, "SystemProperties::getDefaultAudioDriver", aDefaultAudioDriver));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aDefaultAudioDriver);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTAUDIODRIVER_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getDefaultAudioDriver(aDefaultAudioDriver);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTAUDIODRIVER_RETURN(this, hrc, 0 /*normal*/,*aDefaultAudioDriver);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTAUDIODRIVER_RETURN(this, hrc, 1 /*hrc exception*/,*aDefaultAudioDriver);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTAUDIODRIVER_RETURN(this, hrc, 9 /*unhandled exception*/,*aDefaultAudioDriver);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aDefaultAudioDriver=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getDefaultAudioDriver", *aDefaultAudioDriver, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(AutostartDatabasePath)(BSTR *aAutostartDatabasePath)
{
    LogRelFlow(("{%p} %s: enter aAutostartDatabasePath=%p\n", this, "SystemProperties::getAutostartDatabasePath", aAutostartDatabasePath));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aAutostartDatabasePath);
        BSTROutConverter TmpAutostartDatabasePath(aAutostartDatabasePath);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_AUTOSTARTDATABASEPATH_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getAutostartDatabasePath(TmpAutostartDatabasePath.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_AUTOSTARTDATABASEPATH_RETURN(this, hrc, 0 /*normal*/,TmpAutostartDatabasePath.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_AUTOSTARTDATABASEPATH_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_AUTOSTARTDATABASEPATH_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aAutostartDatabasePath=%ls hrc=%Rhrc\n", this, "SystemProperties::getAutostartDatabasePath", *aAutostartDatabasePath, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(AutostartDatabasePath)(IN_BSTR aAutostartDatabasePath)
{
    LogRelFlow(("{%p} %s: enter aAutostartDatabasePath=%ls\n", this, "SystemProperties::setAutostartDatabasePath", aAutostartDatabasePath));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        BSTRInConverter TmpAutostartDatabasePath(aAutostartDatabasePath);

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_AUTOSTARTDATABASEPATH_ENTER(this, TmpAutostartDatabasePath.str().c_str());
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setAutostartDatabasePath(TmpAutostartDatabasePath.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_AUTOSTARTDATABASEPATH_RETURN(this, hrc, 0 /*normal*/,TmpAutostartDatabasePath.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_AUTOSTARTDATABASEPATH_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_AUTOSTARTDATABASEPATH_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setAutostartDatabasePath", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(DefaultAdditionsISO)(BSTR *aDefaultAdditionsISO)
{
    LogRelFlow(("{%p} %s: enter aDefaultAdditionsISO=%p\n", this, "SystemProperties::getDefaultAdditionsISO", aDefaultAdditionsISO));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aDefaultAdditionsISO);
        BSTROutConverter TmpDefaultAdditionsISO(aDefaultAdditionsISO);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTADDITIONSISO_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getDefaultAdditionsISO(TmpDefaultAdditionsISO.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTADDITIONSISO_RETURN(this, hrc, 0 /*normal*/,TmpDefaultAdditionsISO.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTADDITIONSISO_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTADDITIONSISO_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aDefaultAdditionsISO=%ls hrc=%Rhrc\n", this, "SystemProperties::getDefaultAdditionsISO", *aDefaultAdditionsISO, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(DefaultAdditionsISO)(IN_BSTR aDefaultAdditionsISO)
{
    LogRelFlow(("{%p} %s: enter aDefaultAdditionsISO=%ls\n", this, "SystemProperties::setDefaultAdditionsISO", aDefaultAdditionsISO));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        BSTRInConverter TmpDefaultAdditionsISO(aDefaultAdditionsISO);

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTADDITIONSISO_ENTER(this, TmpDefaultAdditionsISO.str().c_str());
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setDefaultAdditionsISO(TmpDefaultAdditionsISO.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTADDITIONSISO_RETURN(this, hrc, 0 /*normal*/,TmpDefaultAdditionsISO.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTADDITIONSISO_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTADDITIONSISO_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setDefaultAdditionsISO", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(DefaultFrontend)(BSTR *aDefaultFrontend)
{
    LogRelFlow(("{%p} %s: enter aDefaultFrontend=%p\n", this, "SystemProperties::getDefaultFrontend", aDefaultFrontend));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aDefaultFrontend);
        BSTROutConverter TmpDefaultFrontend(aDefaultFrontend);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTFRONTEND_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getDefaultFrontend(TmpDefaultFrontend.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTFRONTEND_RETURN(this, hrc, 0 /*normal*/,TmpDefaultFrontend.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTFRONTEND_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_DEFAULTFRONTEND_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aDefaultFrontend=%ls hrc=%Rhrc\n", this, "SystemProperties::getDefaultFrontend", *aDefaultFrontend, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMSETTER(DefaultFrontend)(IN_BSTR aDefaultFrontend)
{
    LogRelFlow(("{%p} %s: enter aDefaultFrontend=%ls\n", this, "SystemProperties::setDefaultFrontend", aDefaultFrontend));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        BSTRInConverter TmpDefaultFrontend(aDefaultFrontend);

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTFRONTEND_ENTER(this, TmpDefaultFrontend.str().c_str());
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setDefaultFrontend(TmpDefaultFrontend.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTFRONTEND_RETURN(this, hrc, 0 /*normal*/,TmpDefaultFrontend.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTFRONTEND_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_SET_DEFAULTFRONTEND_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "SystemProperties::setDefaultFrontend", hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(ScreenShotFormats)(ComSafeArrayOut(BitmapFormat_T, aScreenShotFormats))
{
    LogRelFlow(("{%p} %s: enter aScreenShotFormats=%p\n", this, "SystemProperties::getScreenShotFormats", aScreenShotFormats));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aScreenShotFormats);
        ArrayOutConverter<BitmapFormat_T> TmpScreenShotFormats(ComSafeArrayOutArg(aScreenShotFormats));
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_SCREENSHOTFORMATS_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getScreenShotFormats(TmpScreenShotFormats.array());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_SCREENSHOTFORMATS_RETURN(this, hrc, 0 /*normal*/,(uint32_t)TmpScreenShotFormats.array().size(), NULL /*for now*/);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_SCREENSHOTFORMATS_RETURN(this, hrc, 1 /*hrc exception*/,0, 0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GET_SCREENSHOTFORMATS_RETURN(this, hrc, 9 /*unhandled exception*/,0, 0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aScreenShotFormats=%zu hrc=%Rhrc\n", this, "SystemProperties::getScreenShotFormats", ComSafeArraySize(*aScreenShotFormats), hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute1ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute2ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute3ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute4ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute5ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute6ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute7ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute8ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute9ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute10ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute11ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute12ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute13ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute14ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute15ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::COMGETTER(InternalAndReservedAttribute16ISystemProperties)(ULONG *aReserved)
{
    NOREF(aReserved);
    return E_NOTIMPL;
}


//
// ISystemProperties methods
//

STDMETHODIMP SystemPropertiesWrap::GetMaxNetworkAdapters(ChipsetType_T aChipset,
                                                         ULONG *aMaxNetworkAdapters)
{
    LogRelFlow(("{%p} %s:enter aChipset=%RU32 aMaxNetworkAdapters=%p\n", this, "SystemProperties::getMaxNetworkAdapters", aChipset, aMaxNetworkAdapters));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMaxNetworkAdapters);


        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXNETWORKADAPTERS_ENTER(this, aChipset);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMaxNetworkAdapters(aChipset,
                                        aMaxNetworkAdapters);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXNETWORKADAPTERS_RETURN(this, hrc, 0 /*normal*/, aChipset, *aMaxNetworkAdapters);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXNETWORKADAPTERS_RETURN(this, hrc, 1 /*hrc exception*/, aChipset, *aMaxNetworkAdapters);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXNETWORKADAPTERS_RETURN(this, hrc, 9 /*unhandled exception*/, aChipset, *aMaxNetworkAdapters);
#endif
    }

    LogRelFlow(("{%p} %s: leave aMaxNetworkAdapters=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMaxNetworkAdapters", *aMaxNetworkAdapters, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::GetMaxNetworkAdaptersOfType(ChipsetType_T aChipset,
                                                               NetworkAttachmentType_T aType,
                                                               ULONG *aMaxNetworkAdapters)
{
    LogRelFlow(("{%p} %s:enter aChipset=%RU32 aType=%RU32 aMaxNetworkAdapters=%p\n", this, "SystemProperties::getMaxNetworkAdaptersOfType", aChipset, aType, aMaxNetworkAdapters));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMaxNetworkAdapters);


        
        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXNETWORKADAPTERSOFTYPE_ENTER(this, aChipset, aType);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMaxNetworkAdaptersOfType(aChipset,
                                              aType,
                                              aMaxNetworkAdapters);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXNETWORKADAPTERSOFTYPE_RETURN(this, hrc, 0 /*normal*/, aChipset, aType, *aMaxNetworkAdapters);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXNETWORKADAPTERSOFTYPE_RETURN(this, hrc, 1 /*hrc exception*/, aChipset, aType, *aMaxNetworkAdapters);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXNETWORKADAPTERSOFTYPE_RETURN(this, hrc, 9 /*unhandled exception*/, aChipset, aType, *aMaxNetworkAdapters);
#endif
    }

    LogRelFlow(("{%p} %s: leave aMaxNetworkAdapters=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMaxNetworkAdaptersOfType", *aMaxNetworkAdapters, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::GetMaxDevicesPerPortForStorageBus(StorageBus_T aBus,
                                                                     ULONG *aMaxDevicesPerPort)
{
    LogRelFlow(("{%p} %s:enter aBus=%RU32 aMaxDevicesPerPort=%p\n", this, "SystemProperties::getMaxDevicesPerPortForStorageBus", aBus, aMaxDevicesPerPort));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMaxDevicesPerPort);


        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXDEVICESPERPORTFORSTORAGEBUS_ENTER(this, aBus);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMaxDevicesPerPortForStorageBus(aBus,
                                                    aMaxDevicesPerPort);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXDEVICESPERPORTFORSTORAGEBUS_RETURN(this, hrc, 0 /*normal*/, aBus, *aMaxDevicesPerPort);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXDEVICESPERPORTFORSTORAGEBUS_RETURN(this, hrc, 1 /*hrc exception*/, aBus, *aMaxDevicesPerPort);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXDEVICESPERPORTFORSTORAGEBUS_RETURN(this, hrc, 9 /*unhandled exception*/, aBus, *aMaxDevicesPerPort);
#endif
    }

    LogRelFlow(("{%p} %s: leave aMaxDevicesPerPort=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMaxDevicesPerPortForStorageBus", *aMaxDevicesPerPort, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::GetMinPortCountForStorageBus(StorageBus_T aBus,
                                                                ULONG *aMinPortCount)
{
    LogRelFlow(("{%p} %s:enter aBus=%RU32 aMinPortCount=%p\n", this, "SystemProperties::getMinPortCountForStorageBus", aBus, aMinPortCount));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMinPortCount);


        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMINPORTCOUNTFORSTORAGEBUS_ENTER(this, aBus);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMinPortCountForStorageBus(aBus,
                                               aMinPortCount);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMINPORTCOUNTFORSTORAGEBUS_RETURN(this, hrc, 0 /*normal*/, aBus, *aMinPortCount);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMINPORTCOUNTFORSTORAGEBUS_RETURN(this, hrc, 1 /*hrc exception*/, aBus, *aMinPortCount);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMINPORTCOUNTFORSTORAGEBUS_RETURN(this, hrc, 9 /*unhandled exception*/, aBus, *aMinPortCount);
#endif
    }

    LogRelFlow(("{%p} %s: leave aMinPortCount=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMinPortCountForStorageBus", *aMinPortCount, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::GetMaxPortCountForStorageBus(StorageBus_T aBus,
                                                                ULONG *aMaxPortCount)
{
    LogRelFlow(("{%p} %s:enter aBus=%RU32 aMaxPortCount=%p\n", this, "SystemProperties::getMaxPortCountForStorageBus", aBus, aMaxPortCount));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMaxPortCount);


        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXPORTCOUNTFORSTORAGEBUS_ENTER(this, aBus);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMaxPortCountForStorageBus(aBus,
                                               aMaxPortCount);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXPORTCOUNTFORSTORAGEBUS_RETURN(this, hrc, 0 /*normal*/, aBus, *aMaxPortCount);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXPORTCOUNTFORSTORAGEBUS_RETURN(this, hrc, 1 /*hrc exception*/, aBus, *aMaxPortCount);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXPORTCOUNTFORSTORAGEBUS_RETURN(this, hrc, 9 /*unhandled exception*/, aBus, *aMaxPortCount);
#endif
    }

    LogRelFlow(("{%p} %s: leave aMaxPortCount=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMaxPortCountForStorageBus", *aMaxPortCount, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::GetMaxInstancesOfStorageBus(ChipsetType_T aChipset,
                                                               StorageBus_T aBus,
                                                               ULONG *aMaxInstances)
{
    LogRelFlow(("{%p} %s:enter aChipset=%RU32 aBus=%RU32 aMaxInstances=%p\n", this, "SystemProperties::getMaxInstancesOfStorageBus", aChipset, aBus, aMaxInstances));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMaxInstances);


        
        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXINSTANCESOFSTORAGEBUS_ENTER(this, aChipset, aBus);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMaxInstancesOfStorageBus(aChipset,
                                              aBus,
                                              aMaxInstances);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXINSTANCESOFSTORAGEBUS_RETURN(this, hrc, 0 /*normal*/, aChipset, aBus, *aMaxInstances);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXINSTANCESOFSTORAGEBUS_RETURN(this, hrc, 1 /*hrc exception*/, aChipset, aBus, *aMaxInstances);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXINSTANCESOFSTORAGEBUS_RETURN(this, hrc, 9 /*unhandled exception*/, aChipset, aBus, *aMaxInstances);
#endif
    }

    LogRelFlow(("{%p} %s: leave aMaxInstances=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMaxInstancesOfStorageBus", *aMaxInstances, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::GetDeviceTypesForStorageBus(StorageBus_T aBus,
                                                               ComSafeArrayOut(DeviceType_T, aDeviceTypes))
{
    LogRelFlow(("{%p} %s:enter aBus=%RU32 aDeviceTypes=%p\n", this, "SystemProperties::getDeviceTypesForStorageBus", aBus, aDeviceTypes));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aDeviceTypes);


        
        ArrayOutConverter<DeviceType_T> TmpDeviceTypes(ComSafeArrayOutArg(aDeviceTypes));

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETDEVICETYPESFORSTORAGEBUS_ENTER(this, aBus);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getDeviceTypesForStorageBus(aBus,
                                              TmpDeviceTypes.array());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETDEVICETYPESFORSTORAGEBUS_RETURN(this, hrc, 0 /*normal*/, aBus, (uint32_t)TmpDeviceTypes.array().size(), NULL /*for now*/);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETDEVICETYPESFORSTORAGEBUS_RETURN(this, hrc, 1 /*hrc exception*/, aBus, 0, 0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETDEVICETYPESFORSTORAGEBUS_RETURN(this, hrc, 9 /*unhandled exception*/, aBus, 0, 0);
#endif
    }

    LogRelFlow(("{%p} %s: leave aDeviceTypes=%zu hrc=%Rhrc\n", this, "SystemProperties::getDeviceTypesForStorageBus", ComSafeArraySize(*aDeviceTypes), hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::GetDefaultIoCacheSettingForStorageController(StorageControllerType_T aControllerType,
                                                                                BOOL *aEnabled)
{
    LogRelFlow(("{%p} %s:enter aControllerType=%RU32 aEnabled=%p\n", this, "SystemProperties::getDefaultIoCacheSettingForStorageController", aControllerType, aEnabled));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aEnabled);


        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETDEFAULTSTORAGECTRLCACHESETTING_ENTER(this, aControllerType);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getDefaultIoCacheSettingForStorageController(aControllerType,
                                                               aEnabled);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETDEFAULTSTORAGECTRLCACHESETTING_RETURN(this, hrc, 0 /*normal*/, aControllerType, *aEnabled != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETDEFAULTSTORAGECTRLCACHESETTING_RETURN(this, hrc, 1 /*hrc exception*/, aControllerType, *aEnabled != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETDEFAULTSTORAGECTRLCACHESETTING_RETURN(this, hrc, 9 /*unhandled exception*/, aControllerType, *aEnabled != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave aEnabled=%RTbool hrc=%Rhrc\n", this, "SystemProperties::getDefaultIoCacheSettingForStorageController", *aEnabled, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::GetStorageControllerHotplugCapable(StorageControllerType_T aControllerType,
                                                                      BOOL *aHotplugCapable)
{
    LogRelFlow(("{%p} %s:enter aControllerType=%RU32 aHotplugCapable=%p\n", this, "SystemProperties::getStorageControllerHotplugCapable", aControllerType, aHotplugCapable));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aHotplugCapable);


        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETSTORAGECONTROLLERHOTPLUGCAPABLE_ENTER(this, aControllerType);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getStorageControllerHotplugCapable(aControllerType,
                                                     aHotplugCapable);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETSTORAGECONTROLLERHOTPLUGCAPABLE_RETURN(this, hrc, 0 /*normal*/, aControllerType, *aHotplugCapable != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETSTORAGECONTROLLERHOTPLUGCAPABLE_RETURN(this, hrc, 1 /*hrc exception*/, aControllerType, *aHotplugCapable != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETSTORAGECONTROLLERHOTPLUGCAPABLE_RETURN(this, hrc, 9 /*unhandled exception*/, aControllerType, *aHotplugCapable != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave aHotplugCapable=%RTbool hrc=%Rhrc\n", this, "SystemProperties::getStorageControllerHotplugCapable", *aHotplugCapable, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::GetMaxInstancesOfUSBControllerType(ChipsetType_T aChipset,
                                                                      USBControllerType_T aType,
                                                                      ULONG *aMaxInstances)
{
    LogRelFlow(("{%p} %s:enter aChipset=%RU32 aType=%RU32 aMaxInstances=%p\n", this, "SystemProperties::getMaxInstancesOfUSBControllerType", aChipset, aType, aMaxInstances));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMaxInstances);


        
        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXINSTANCESOFUSBCONTROLLERTYPE_ENTER(this, aChipset, aType);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMaxInstancesOfUSBControllerType(aChipset,
                                                     aType,
                                                     aMaxInstances);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXINSTANCESOFUSBCONTROLLERTYPE_RETURN(this, hrc, 0 /*normal*/, aChipset, aType, *aMaxInstances);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXINSTANCESOFUSBCONTROLLERTYPE_RETURN(this, hrc, 1 /*hrc exception*/, aChipset, aType, *aMaxInstances);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_SYSTEMPROPERTIES_GETMAXINSTANCESOFUSBCONTROLLERTYPE_RETURN(this, hrc, 9 /*unhandled exception*/, aChipset, aType, *aMaxInstances);
#endif
    }

    LogRelFlow(("{%p} %s: leave aMaxInstances=%RU32 hrc=%Rhrc\n", this, "SystemProperties::getMaxInstancesOfUSBControllerType", *aMaxInstances, hrc));
    return hrc;
}

STDMETHODIMP SystemPropertiesWrap::InternalAndReservedMethod1ISystemProperties()
{
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::InternalAndReservedMethod2ISystemProperties()
{
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::InternalAndReservedMethod3ISystemProperties()
{
    return E_NOTIMPL;
}

STDMETHODIMP SystemPropertiesWrap::InternalAndReservedMethod4ISystemProperties()
{
    return E_NOTIMPL;
}

#ifdef VBOX_WITH_XPCOM
NS_DECL_CLASSINFO(SystemPropertiesWrap)
NS_IMPL_THREADSAFE_ISUPPORTS1_CI(SystemPropertiesWrap, ISystemProperties)
#endif // VBOX_WITH_XPCOM
